# cWorldManager Class Reference

List of all members.

## Public Types

typedef std::vector < ConfirmPanel >::iterator | iterConfirmPanel_lst

## Static Public Member Functions

static void | Load ()
static void | Unload ()
static BOOL | RemoveClient (cClient *pcClient, BOOL fRemoveAvatar=TRUE, BOOL fDeleteAvatar=TRUE)
static BOOL | AddClient (cClient *pcClient, BOOL fSpawnAvatar=TRUE)
static BOOL | MoveAvatar (cClient *pcClient, cLocation &NewLoc, WORD wAnim=0, float flPlaySpeed=1.0f)
static BOOL | TeleportAvatar (cClient *pcClient, cLocation &NewLoc)
static BOOL | RemoveObject (cObject *pcObject, BOOL fRemoveObject=TRUE, BOOL fDeleteObject=TRUE)
static BOOL | AddObject (cObject *pcObject, BOOL fSpawnObject=TRUE)
static BOOL | MoveAddObject (cObject *pcObject)
static BOOL | MoveRemObject (cObject *pcObject)
static void | RemoveAllObjects ()
static void | SendToAllInLandBlock (cLocation &Loc, cMessage &cmPacket, WORD wGroup)
static void | SendToAllInFocus (cLocation &Loc, cMessage &cmPacket, WORD wGroup)
static void | SendToAllWithin (BYTE bDistance, cLocation &Loc, cMessage &cmPacket, WORD wGroup)
static void | SendToOthersInLandBlock (cLocation &Loc, cClient *pcClient, cMessage &cmPacket, WORD wGroup)
static void | SendToOthersInFocus (cLocation &Loc, cClient *pcClient, cMessage &cmPacket, WORD wGroup)
static void | SendToOthersWithin (BYTE bDistance, cLocation &Loc, cClient *pcClient, cMessage &cmPacket, WORD wGroup)
static cObject * | GetCollisionPortal (cLocation OldLoc, cLocation NewLoc)
static cObject * | GetCollisionMonster (DWORD SpellGUID, cLocation SpellLoc)
static cObject * | FindObject (DWORD dwGUID)
static cCorpse * | FindCorpse (DWORD dwGUID)
static cAvatar * | FindAvatar (DWORD dwGUID)
static cNPC * | FindNPC (DWORD dwGUID)
static UINT | NewGUID_Avatar ()
static UINT | NewGUID_Object ()
static void | AddUnusedAvatarGUID (DWORD dwGUID)
static void | AddUnusedObjectGUID (DWORD dwGUID)
static DWORD | GetUnusedAvatarGUID ()
static DWORD | GetUnusedObjectGUID ()
static DWORD | CurrentConfirmSeq ()
static DWORD | NewConfirmSeq ()
static void | AddPendingConfirm (DWORD sequence, DWORD type, std::string szText, DWORD senderGUID, DWORD receiptGUID=NULL)
static void | FindPendingConfirm (DWORD dwSeq, DWORD dwReply)

## Static Public Attributes

static char | g_szAccessFile [MAX_PATH+20]

## Friends

class | cMasterServer

## Member Function Documentation

BOOL cWorldManager::AddClient | ( | cClient * | pcClient,
|  | BOOL | fSpawnAvatar = `TRUE` |
| ) |  |  | `[static]`

Handles the processing for when a client is added to the server.

This function is called whenever an avatar is added to the server.

Parameters:

  | *pcClient | - A pointer to the client whose avatar is being added.
  | fSpawnAvatar | - A value representing whether the avatar should be spawned.

BOOL cWorldManager::AddObject | ( | cObject * | pcObject,
|  | BOOL | fSpawnObject = `TRUE` |
| ) |  |  | `[static]`

Adds an object to object list of the landblock in which it is located.

Parameters:

  | *pcObject | - A pointer to the object to add.
  | fSpawnObject | - A value representing whether the object should be spawned.

void cWorldManager::Load | ( |  | ) | `[static]`

Loads the initial world objects

This function is called when the server is started.

BOOL cWorldManager::MoveAddObject | ( | cObject * | pcObject | ) | `[static]`

Adds an object to object list of the landblock in which it is located.

Used for when an object changes landblock location.

Parameters:

  | *pcObject | - A pointer to the object to add.

BOOL cWorldManager::MoveAvatar | ( | cClient * | pcClient,
|  | cLocation & | NewLoc,
|  | WORD | wAnim = `0`,
|  | float | flPlaySpeed = `1.0f` |
| ) |  |  | `[static]`

Handles the processing for when an avatar moves.

This function is called whenever an avatar moves. The function checks whether the avatar has moved into a new landblock and populates/depopulates landblocks appropriately. The function also sends the movement animation to all clients within focus.

Parameters:

  | *pcClient | - A pointer to the client whose avatar is being teleported.
  | &NewLoc | - The address of the cLocation struct value that represents the location to which the avatar is being teleported.
  | wAnim | - The numeric value of the animation to play.
  | flPlay | - The speed at which to play the gievn animation.

Returns:
  BOOL - A boolean value representing whether the avatar's landblock has not changed.

BOOL cWorldManager::MoveRemObject | ( | cObject * | pcObject | ) | `[static]`

Removes an object from the object list of the landblock in which it is located.

Used for when an object changes landblock location.

Parameters:

  | *pcObject | - A pointer to the object to remove.

Returns:
  BOOL - A boolean value representing whether the object is located in a known landblock.

void cWorldManager::RemoveAllObjects | ( |  | ) | `[static]`

Removes all object from the object list of all the landblocks.

This is accomplished by iterating through each landblock, for each landblock iterating through each object, and deleting the objects as they are iterated through.

BOOL cWorldManager::RemoveClient | ( | cClient * | pcClient,
|  | BOOL | fRemoveAvatar = `TRUE`,
|  | BOOL | fDeleteAvatar = `TRUE` |
| ) |  |  | `[static]`

Handles the processing for when a client is removed from the server.

This function is called whenever an avatar removed from the server

Parameters:

  | *pcClient | - A pointer to the client whose avatar is being removed.
  | fRemoveAvatar | - A value representing whether the avatar should be removed.
  | fDeleteavatar | - A value representing whether the avatar object should be deleted from working memory.

Returns:
  BOOL - A boolean value representing whether the avatar is located in a known landblock.

BOOL cWorldManager::RemoveObject | ( | cObject * | pcObject,
|  | BOOL | fRemoveObject = `TRUE`,
|  | BOOL | fDeleteObject = `TRUE` |
| ) |  |  | `[static]`

Removes an object to object list of the landblock in which it is located.

Parameters:

  | *pcObject | - A pointer to the object to remove.
  | fRemoveObject | - A value representing whether the object should be removed.
  | fDeleteObject | - A value representing whether the object should be deleted from working memory.

BOOL cWorldManager::TeleportAvatar | ( | cClient * | pcClient,
|  | cLocation & | NewLoc |
| ) |  |  | `[static]`

Handles the processing for when an avatar is teleported

This function is called whenever an avatar is teleported.

Parameters:

  | *pcClient | - A pointer to the client whose avatar is being teleported.
  | &NewLoc | - The address of the cLocation struct value that represents the location to which the avatar is being teleported.

Returns:
  BOOL - A boolean value representing whether the avatar's landblock has not changed.

The documentation for this class was generated from the following files:

- E:/uas2/Server/WorldManager.h
- E:/uas2/Server/WorldManager.cpp